searchData={"items":[{"type":"module","title":"Link","doc":"`Link` is a little link parsing, compacting and shortening library.","ref":"Link.html"},{"type":"function","title":"Link.compact/1","doc":"`compact/1` reduces a url to its most compact form.\nThis is highly specific to our use case.","ref":"Link.html#compact/1"},{"type":"function","title":"Examples - Link.compact/1","doc":"iex> Link.compact(\"https://github.com/dwyl/mvp/issues/141\")\n    \"dwyl/mvp#141\"\n\n    # Can't understand the URL, just return it sans protocol:\n    iex> Link.compact(\"https://git.io/top\")\n    \"git.io/top\"\n\n    iex> Link.compact(\"https://mvp.fly.dev/\")\n    \"mvp.fly.dev\"","ref":"Link.html#compact/1-examples"},{"type":"function","title":"Link.compact_github_url/1","doc":"`compact_github_url/1` does exactly as its' name implies:\ncompact a GitHub URL down to it's simplest version\nso that we aren't wasting characters on a mobile screen.","ref":"Link.html#compact_github_url/1"},{"type":"function","title":"Examples - Link.compact_github_url/1","doc":"iex> Link.compact_github_url(\"https://github.com/dwyl/mvp/issues/141\")\n  \"dwyl/mvp#141\"\n\n  iex> Link.compact_github_url(\"https://github.com/dwyl/app/issues/275#issuecomment-1646862277\")\n  \"dwyl/app#275\"\n\n  iex> Link.compact_github_url(\"https://github.com/dwyl/link#123\")\n  \"dwyl/link\"","ref":"Link.html#compact_github_url/1-examples"},{"type":"function","title":"Link.find/1","doc":"`find/1` finds all instances of a URL in a block of text.","ref":"Link.html#find/1"},{"type":"function","title":"Examples - Link.find/1","doc":"iex> Link.find(\"Text with links http://goo.gl/3co4ae and https://git.io/top & www.dwyl.com etc.\")\n  [\"http://goo.gl/3co4ae\", \"https://git.io/top\", \"www.dwyl.com\"]","ref":"Link.html#find/1-examples"},{"type":"function","title":"Link.find_replace_compact/1","doc":"`find_replace_compact/1` finds all instances of a URL in a block of text\nand replaces them with the `compact/1` version.","ref":"Link.html#find_replace_compact/1"},{"type":"function","title":"Examples - Link.find_replace_compact/1","doc":"iex> md = \"# Hello World! https://github.com/dwyl/mvp/issues/141#issuecomment-1657954420 and https://mvp.fly.dev/\"\n  iex> Link.find_replace_compact(md)\n  \"# Hello World! ![dwyl/mvp#141](https://github.com/dwyl/mvp/issues/141#issuecomment-1657954420) and ![mvp.fly.dev](https://mvp.fly.dev/)\"","ref":"Link.html#find_replace_compact/1-examples"},{"type":"function","title":"Link.regex/0","doc":"`regex/0` returns the Regular Expression needed to match URLs.\nAccording to `RFC 3986`: https://www.rfc-editor.org/rfc/rfc3986\nBased on reading https://mathiasbynens.be/demo/url-regex\nAfter much searching on Google, GitHub and StackOverflow,\nthis is what we came up with.\n\n#HELPWANTED: if you find a *better* (faster, more comppliant) RegEx\nthat passes all our tests, please share! github.com/dwyl/link/issues/new\n\nExplanation:\n\n((http(s)?)://             # Optional scheme (http or https)\n(www.)?                     # Optional \"www\"\na-zA-Z0-9@:%._+~#=]{2,256}  # Domain (IPv4, IPv6 or hostname)\n:%                           # Optional port number\n[a-z]{2,6}\b                 # Domain extension e.g: \".com\"\n(?:?[^\n\r]*)?              # Optional query string ?q=\n(?:#[^\n\r]*)?               # Optional fragment e.g: #comment","ref":"Link.html#regex/0"},{"type":"function","title":"Examples - Link.regex/0","doc":"iex> Regex.run(Link.regex(), \"dwyl.com\") |> List.flatten |> Enum.filter(& &1 != \"\") |> List.first\n  \"dwyl.com\"","ref":"Link.html#regex/0-examples"},{"type":"function","title":"Link.strip_protocol/1","doc":"`strip_protocol/1` strips the protocol e.g: \"https://\" from a URL.","ref":"Link.html#strip_protocol/1"},{"type":"function","title":"Examples - Link.strip_protocol/1","doc":"iex> Link.strip_protocol(\"https://dwyl.com\")\n  \"dwyl.com\"","ref":"Link.html#strip_protocol/1-examples"},{"type":"function","title":"Link.strip_trailing_slash/1","doc":"`strip_trailing_slash/1` strips trailing forward slash from URL.","ref":"Link.html#strip_trailing_slash/1"},{"type":"function","title":"Examples - Link.strip_trailing_slash/1","doc":"iex> Link.strip_trailing_slash(\"dwyl.com/\")\n  \"dwyl.com\"","ref":"Link.html#strip_trailing_slash/1-examples"},{"type":"function","title":"Link.valid?/1","doc":"`valid?/1` confirms if a URL is valid\nusing the `RFC 3986` compliant `regex/0` above.","ref":"Link.html#valid?/1"},{"type":"function","title":"Examples - Link.valid?/1","doc":"iex> Link.valid?(\"example.c\")\n  false\n\n  iex> Link.valid?(\"https://www.example.com\")\n  true","ref":"Link.html#valid?/1-examples"}],"content_type":"text/markdown"}